var gulp = require('gulp');
var path = require('path');
var sass = require('gulp-sass');
var extend = require('extend');

/**
 * config
 *    sass
 *        sassSrc:  sass源文件所在目录
 *        sassDist: sass预处理后的目标目录
 *        sassOpt:  node-sass的相关配置
 */
function registerTask(config) {
    registerSassTask(config.sass);
}

/**
 * 注册sass的预处理task
 */
function registerSassTask(config) {
    var sassOpt = {
        includePaths: [config.sassSrc, '../compass-mixins/lib'],
        outputStyle: 'expanded'
    };
    sassOpt = extend(false, config.sassOpt || {});
    gulp.task('sass-preprocess', function() {
        return gulp.src(config.sassSrc + '/**/*.scss')
            .pipe(sass(sassOpt).on('error', sass.logError))
            .pipe(gulp.dest(config.sassDist));
    });
}

module.exports = registerTask;